package log

import "io"

var std = New("")

func Sub(sys string) *Logger {
	return std.Sub(sys)
}

func SetColor(c bool) {
	std.SetColor(c)
}

func SetErrOutput(err io.Writer) {
	std.SetErrOutput(err)
}

func SetErrOutputAll(err io.Writer) {
	std.SetErrOutputAll(err)
}

func SetOutput(out io.Writer) {
	std.SetOutput(out)
}

func SetOutputAll(out io.Writer) {
	std.SetOutputAll(out)
}

func Reload() error {
	return std.Reload()
}

func ReloadAll() error {
	return std.ReloadAll()
}

func ErrorF(fields H, v ...interface{}) {
	if PROD {
		std.output(terror, 3, "", fields, v...)
	} else {
		std.output(terror, 3, stack(), fields, v...)
	}
}

func Error(v ...interface{}) {
	if PROD {
		std.output(terror, 3, "", H{}, v...)
	} else {
		std.output(terror, 3, stack(), H{}, v...)
	}
}

func DebugF(fields H, v ...interface{}) {
	if PROD {
		std.output(tdebug, 3, "", fields, v...)
	} else {
		std.output(tdebug, 3, stack(), fields, v...)
	}
}

func Debug(v ...interface{}) {
	if PROD {
		std.output(tdebug, 3, "", H{}, v...)
	} else {
		std.output(tdebug, 3, stack(), H{}, v...)
	}
}

func WarnF(fields H, v ...interface{}) {
	std.output(twarn, 3, "", fields, v...)
}

func Warn(v ...interface{}) {
	std.output(twarn, 3, "", H{}, v...)
}

func InfoF(fields H, v ...interface{}) {
	std.output(tinfo, 3, "", fields, v...)
}

func Info(v ...interface{}) {
	std.output(tinfo, 3, "", H{}, v...)
}
